package imp.parser;

import imp.slicer.AssignNode;
import imp.slicer.Cfg;
import imp.util.Util;

public class AssignStmt extends Stmt {
    public Var var; 
    public Exp exp; 
    
    public AssignStmt(Loc from, Var var, Exp exp) {
    	super(from);
    	this.var = var; 
    	this.exp = exp; 
    }
    
    public String toString() {
    	return this.toString(0);
    }
    
    public String toString(int i) {
    	String locStr = from.toString();
    	String varStr = var.toString();
    	String expStr = exp.toString();
    	String indStr = Util.makeIndentStr(i);
    	return locStr+indStr+varStr+" := "+expStr;
    }
    
    public Cfg toCfg(int indentLevel) {
    	AssignNode n = new AssignNode(this, indentLevel, from);
    	return new Cfg(n, n);
    }
    
} // public class AssignStmt extends Stmt 
