package imp.parser;

import java.io.*;
import java_cup.runtime.*;

public class Parse { 
    static final boolean do_debug_parse = false;

    public static Program parse(String fn) throws java.lang.Exception {
	System.out.println("Reading Imp program from file "+fn);
	try {
	    BufferedReader in = new BufferedReader(new FileReader(fn));
	    // create a parsing object //
	    lexer theLexer = new lexer(in);
	    parser theParser = new parser(theLexer);
	    
	    // parse result is of type Symbol declared in java_cup/runtime/Symbol.java
	    Symbol parse_result = null;
	    if (do_debug_parse) 
		parse_result = theParser.debug_parse();
	    else
		parse_result = theParser.parse();
	    Program prog = (Program) (parse_result.value);
	    return prog;
	} 
    	catch (IOException e) {
    		System.out.println("ERROR: Couldn't read from file " + fn+", terminating");
    		System.exit(1);
    		return null;
    	} // end try/catch
    }
    
} // class Parse

