package imp.parser;

import imp.util.Util;

public class Program {
    public String id; 
    public VarDeclList varDeclList; 
    public ProgramBody programBody;
    
    public Program(String id, VarDeclList varDeclList, ProgramBody progBody ) {
    	this.id = id;
    	this.varDeclList = varDeclList;
    	this.programBody = progBody;
    }
    
    public String toString (int i) {
    	String indStr = Util.makeIndentStr(i);
    	String header = indStr + "PROGRAM "+id+";\n";
    	String programBodyStr = programBody.toString(i);	
    	if (varDeclList == null)
    		return header+programBodyStr;
    	else {
    		String varDeclListStr = varDeclList.toString(i+1);
    		return header+indStr+"VAR\n"+varDeclListStr+"\n"+programBodyStr;
    	}
    }
    
} // public class Program 

