package imp.parser;

import imp.slicer.Cfg;

public abstract class Stmt {
    public Loc from;
    public Loc to;
    
    public Stmt(Loc from) {
		this.from = from;
		this.to = null;
    }
    
    public Stmt(Loc from, Loc to) {
		this.from = from;
		this.to = to;
    }
    
    public boolean startsAtLoc(int i) {
    	return from.contains(i);
    }
    
    abstract public String toString(int i);
    
    /**
     * Produces the control flow graph representing this statement.
     */
    abstract public Cfg toCfg(int indentLevel);
    
} // public abstract class Stmt
