package imp.parser;

import imp.slicer.Cfg;
import imp.slicer.Node;

public class StmtList {
    public Stmt stmt; 
    public StmtList next; 
    
    public StmtList(Stmt stmt, StmtList next) {
		this.stmt = stmt; 
		this.next = next;
    }
    public String toString(int i) {
    	if (next == null) {
    		String stmtStr = stmt.toString(i);
    		return stmtStr+"\n";
    	}
    	else {
    		String stmtStr = stmt.toString(i);
    		String stmtListStr = next.toString(i);
    		return stmtStr+";\n"+stmtListStr;
    	}
    }

    static public Stmt getStmtStartingAt(StmtList stmtList, int i) {
		if (stmtList == null) 
		    return null;
		else {
		    Stmt s = stmtList.stmt;
		    Stmt res = null;
		    if (s.startsAtLoc(i)) 
			res = s;
		    else if (s instanceof IfThenElseStmt) {
				res = getStmtStartingAt(((IfThenElseStmt) s).thenStmtList, i);
				if (res == null) 
				    res = getStmtStartingAt(((IfThenElseStmt) s).elseStmtList, i);
		    }
		    else if (res == null && (s instanceof WhileStmt))
		    	res = getStmtStartingAt(((WhileStmt) s).stmtList, i);
		    else res = getStmtStartingAt(stmtList.next, i);
		    return res;
		}
    }
    
    public Cfg toCfg(int i) {
    	Cfg cfg1 = stmt.toCfg(i);
    	if (next == null) 
	    return cfg1;
    	else {
	    Cfg cfg2 = next.toCfg(i);
	    Node first1 = cfg1.first;
	    Node last1 = cfg1.last;
	    Node first2 = cfg2.first;
	    Node last2 = cfg2.last;
	    last1.addNext(first2);
	    first2.addPrev(last1);
	    return new Cfg(first1, last2);
    	}
    }
    
} // class StmtList 

