package imp.slicer;

import imp.parser.Loc;
import imp.util.Util;
import imp.util.VarIdSet;

public class ProgramBeginNode extends Node {
	
    public ProgramBeginNode(Loc l, int i) {
      super(i, l);
    }
    
    public String toString() {
    	String locStr = loc.toString();
    	String indStr = Util.makeIndentStr(indentLevel);
    	return locStr + indStr + "BEGIN";
    }
   
    
    /**
     * This is method should never be called. It's only there to keep the compiler 
     * happy.  
     */
    public void computeDRVars(Node cNode, VarIdSet cVars) {
    	System.out.println("ERROR: Called computeDRVars on ProgramBeginNode. Terminating.");
    	System.exit(1);
    }
    
} // public class ProgramBeginNode extends Node
