package imp.slicer;

import imp.parser.Loc;
import imp.util.VarIdSet;
import imp.util.Util;

/**
 * Dummy node to represent the "REPEAT" keyword. It's necessary to 
 * be able to clearly separate the nodes in the body of the repeat 
 * from the nodes before the repeat
 */
public class RepeatNode extends Node {
    public RepeatTestNode repeatTestNode;
    
    public RepeatNode (int i, Loc loc, RepeatTestNode testNode) {
    	super(i, loc);
    	this.repeatTestNode = testNode;
    }
    
    public String toString() {
       	String locStr = loc.toString();
    	String indStr = Util.makeIndentStr(indentLevel);
    	return locStr+indStr+"REPEAT";
    }
    
    public String toString(Node stopNode) {
    	if (this != stopNode) {
    		String str = this.toString()+"\n";
    		Node firstBodyNode = this.getNext();
			str = str + (firstBodyNode.toString(this.repeatTestNode));
			str = str + this.repeatTestNode.toString();
			// is there more?
			if (stopNode != repeatTestNode) {
				Node firstNodeAfterRepeat = this.repeatTestNode.getFirstNodeOutside();
				str = str + "\n" + firstNodeAfterRepeat.toString(stopNode);
			}
    		return str;
    	}
    	else 
    		return "";
    }
    
    public String toStringUsingRelevant(Node stopNode) {
    	if (this != stopNode) {
    		String str = "";
    		if (this.isRelevant) {
    			str = this.toString()+"\n";
    			Node firstBodyNode = this.getNext();
    			str = str + (firstBodyNode.toStringUsingRelevant(this.repeatTestNode));
    			str = str + this.repeatTestNode.toString();
    		}
			// is there more?
			if (stopNode != this.repeatTestNode) {
				Node firstNodeAfterRepeat = this.repeatTestNode.getFirstNodeOutside();
				str = str + firstNodeAfterRepeat.toStringUsingRelevant(stopNode);
			}
    		return str;
    	}
    	else 
    		return "";
    }

    /** Fill in this method
     */
    public void computeDRVars(Node cNode, VarIdSet cVars) {
    }
    
} // public class Node
