/** 
 * CISC422/853: ASSIGNMENT 4, March 2009
 * Instructor: Juergen Dingel
 * File: test.java
 * 
 * * A bit of code that accesses the statement list and the CFG. 
 * It contains only one method called test which will explore 
 * a cfg in three different, hard-coded ways. Not really necessary
 * for this assignment. Only included for illustration purposes.
 */
package imp;

import java.util.Vector;
import java.util.Random;
import imp.parser.*;
import imp.slicer.Cfg;
import imp.slicer.Node;

class Test { 
    private static final int TEST_NUM = 3;
    
    public static void test(ProgramBody progBody, Cfg cfg) {
		System.out.println("Here're the statements:");
		System.out.println(progBody.toString(0));
		StmtList stmtList = progBody.stmtList;
		try {
		    // grab statement in program at location number 3
		    System.out.println("Here's the statement at location 3:");
		    Stmt s = StmtList.getStmtStartingAt(stmtList, 3);
		    System.out.println( s.toString(0) );
		}
		catch (java.lang.Exception e) {
		    System.out.println("There's no statement at location 3\n");
		}
		// grab first node of CFG
		System.out.println("Here's the first node of CFG:");
		Node n1 = cfg.first;
		System.out.println(n1.toString());
		// grab last node of CFG
		System.out.println( "Here's the last node of CFG:" );
		Node n2 = cfg.last;
		System.out.println(n2.toString());
		switch (TEST_NUM) {
		    case 0: 
			break;
		    case 1: 
		    	// explore CFG by starting at first node always taking first successor
		    	// if CFG cyclic this loop will not terminate
		    	System.out.println( "Test 1: Explore CFG starting at first node and always take first successor (may not terminate)" );
		    	while (!(n1==null)) {
		    		System.out.println( "current node:" );
		    		System.out.println(n1.toString());
		    		Vector successors = n1.nexts;
		    		if (successors.isEmpty()) 
		    			n1 = null;
		    		else
		    			// first successor becomes current node
		    			n1 = (Node) successors.get(0);
		    	}
		    	break;
		    case 2: 
		    	// explore CFG by starting at last node and always taking first successor 
		    	// if CFG cyclic this loop will not terminate
		    	System.out.println( "Test 2: Explore CFG starting at last node and always take first predecessor (may not terminate)" );
		    	while (!(n2==null)) {
				    System.out.println("current node:");
				    System.out.println(n2.toString());
				    Vector predecessors = n2.prevs;
				    if (predecessors.isEmpty()) 
				    	n2 = null;
				    else
						// first predecessor becomes current node
						n2 = (Node) predecessors.get(0);
		    	}
		    	break;
		    case 3: 
		    	// explore CFG by starting at first node and always taking a randomly 
		    	// chosen successor. 
				// if CFG cyclic this loop may not terminate
				System.out.println( "Test 3: Explore CFG starting at first node and pick successors randomly (may not terminate)" );
				// create random number generator
				Random rg = new Random();
				while (!(n1==null)) {
				    System.out.println( "current node:" );
				    System.out.println(n1.toString());
				    Vector successors = n1.nexts;
				    int num = successors.size();
				    if (num == 0) 
				    	n1 = null;
				    else {
						// random successor becomes current node
						int random = rg.nextInt(num);
						n1 = (Node) successors.get(random);
				    }
				}
				break;
		}
    }
    
} // class Test
